diff --git a/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-func.c b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-func.c
new file mode 100644
index 00000000000..b2d6820cf23
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-func.c
@@ -0,0 +1,18 @@
+
+/* { dg-do compile )  */
+/* { dg-options "-O0 -gbtf -dA" } */
+
+/* { dg-final { scan-assembler-times "\[\t \]0x11000000\[\t \]+\[^\n\]*btt_info" 4 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0xffffffff\[\t \]+\[^\n\]*decltag_compidx" 3 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0x1\[\t \]+\[^\n\]*decltag_compidx" 1 } } */
+
+#define __tag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __tag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __tag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+extern int bar (int __tag1, int __tag2) __tag3;
+
+int __tag1 __tag2 foo (int arg1, int *arg2 __tag2)
+  {
+    return bar (arg1 + 1, *arg2 + 2);
+  }
diff --git a/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-sou.c b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-sou.c
new file mode 100644
index 00000000000..bb125b53ce7
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-sou.c
@@ -0,0 +1,34 @@
+
+/* { dg-do compile )  */
+/* { dg-options "-O0 -gbtf -dA" } */
+
+/* { dg-final { scan-assembler-times "\[\t \]0x11000000\[\t \]+\[^\n\]*btt_info" 16 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0\[\t \]+\[^\n\]*decltag_compidx" 2 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0x1\[\t \]+\[^\n\]*decltag_compidx" 1 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0x2\[\t \]+\[^\n\]*decltag_compidx" 3 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0x3\[\t \]+\[^\n\]*decltag_compidx" 3 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0x4\[\t \]+\[^\n\]*decltag_compidx" 1 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0xffffffff\[\t \]+\[^\n\]*decltag_compidx" 6 } } */
+
+#define __tag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __tag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __tag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+struct t {
+  int a;
+  long b __tag3;
+  char c __tag2 __tag3;
+} __tag1 __tag2;
+
+struct t my_t __tag1 __tag3;
+
+
+union u {
+  char one __tag1 __tag2;
+  short two;
+  int three __tag1;
+  long four __tag1 __tag2 __tag3;
+  long long five __tag2;
+} __tag3;
+
+union u my_u __tag2;
diff --git a/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-typedef.c b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-typedef.c
new file mode 100644
index 00000000000..6a44aaf9623
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/btf/btf-decltag-typedef.c
@@ -0,0 +1,15 @@
+/* { dg-do compile )  */
+/* { dg-options "-O0 -gbtf -dA" } */
+
+/* { dg-final { scan-assembler-times "\[\t \]0x11000000\[\t \]+\[^\n\]*btt_info" 3 } } */
+/* { dg-final { scan-assembler-times "\[\t \]0xffffffff\[\t \]+\[^\n\]*decltag_compidx" 3 } } */
+
+#define __tag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __tag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __tag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+struct s { int a; } __tag1;
+
+typedef struct s * sptr __tag2;
+
+sptr my_sptr __tag3;
diff --git a/gcc/testsuite/gcc.dg/debug/btf/btf-typetag-1.c b/gcc/testsuite/gcc.dg/debug/btf/btf-typetag-1.c
new file mode 100644
index 00000000000..0d046265b7a
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/btf/btf-typetag-1.c
@@ -0,0 +1,20 @@
+/* { dg-do compile )  */
+/* { dg-options "-O0 -gbtf -dA" } */
+
+/* { dg-final { scan-assembler-times "\[\t \]0x12000000\[\t \]+\[^\n\]*btt_info" 4 } } */
+
+#define __tag1 __attribute__((debug_annotate_type("tag1")))
+#define __tag2 __attribute__((debug_annotate_type("tag2")))
+#define __tag3 __attribute__((debug_annotate_type("tag3")))
+
+int __tag1 * x;
+const int __tag2 * y;
+
+struct a;
+
+struct b
+{
+  struct a __tag2 __tag3 * inner_a;
+};
+
+struct b my_b;
diff --git a/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-1.c b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-1.c
new file mode 100644
index 00000000000..f6f305c2739
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-1.c
@@ -0,0 +1,20 @@
+/* { dg-do compile } */
+/* { dg-options "-gdwarf -dA" } */
+#define __decltag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __decltag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __decltag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+struct S {
+  int a __decltag2 __decltag3;
+  int b __decltag1;
+} __decltag1 __decltag2;
+
+struct S my_S __decltag3;
+
+/* Verify that we get the expected DW_TAG_GNU_annotation DIEs for each tag.
+   Note: one more TAG in debug abbrev.  */
+/* { dg-final { scan-assembler-times " DW_TAG_GNU_annotation" 7 } } */
+/* { dg-final { scan-assembler-times " DW_AT_name: \"debug_annotate_decl\"" 6 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-1\"" 2 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-2\"" 2 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-3\"" 2 } } */
diff --git a/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-2.c b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-2.c
new file mode 100644
index 00000000000..04628fb1b81
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-2.c
@@ -0,0 +1,17 @@
+/* { dg-do compile } */
+/* { dg-options "-gdwarf -dA" } */
+#define __typetag1 __attribute__((debug_annotate_type("type-tag-1")))
+#define __typetag2 __attribute__((debug_annotate_type("type-tag-2")))
+#define __typetag3 __attribute__((debug_annotate_type("type-tag-3")))
+int __typetag1 * x;
+
+char * __typetag1 buf;
+
+int * __typetag1 * __typetag2 __typetag3 g;
+
+/* Verify we get the expected annotation dies. Note +1 TAG in debug abbrev.  */
+/* { dg-final { scan-assembler-times " DW_TAG_GNU_annotation" 6 } } */
+/* { dg-final { scan-assembler-times " DW_AT_name: \"debug_annotate_type\"" 5 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-1\"" 3 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-2\"" 1 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-3\"" 1 } } */
diff --git a/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-3.c b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-3.c
new file mode 100644
index 00000000000..0548cd52d6d
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-3.c
@@ -0,0 +1,20 @@
+/* { dg-do compile } */
+/* { dg-options "-gdwarf -dA" } */
+#define __decltag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __decltag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __decltag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+extern int foo (char a, int b) __decltag1 __decltag3;
+
+int bar (int x)
+{
+  return foo ('a', x);
+}
+
+/* Verify that we get the expected DW_TAG_GNU_annotation DIEs for each tag.
+   Note: one more TAG in debug abbrev.  */
+/* { dg-final { scan-assembler-times " DW_TAG_GNU_annotation" 3 } } */
+/* { dg-final { scan-assembler-times " DW_AT_name: \"debug_annotate_decl\"" 2 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-1\"" 1 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-2\"" 0 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-3\"" 1 } } */
diff --git a/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-4.c b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-4.c
new file mode 100644
index 00000000000..9d2b3ad5c00
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/dwarf2/annotation-4.c
@@ -0,0 +1,34 @@
+/* { dg-do compile } */
+/* { dg-options "-gdwarf -dA" } */
+#define __decltag1 __attribute__((debug_annotate_decl("decl-tag-1")))
+#define __decltag2 __attribute__((debug_annotate_decl("decl-tag-2")))
+#define __decltag3 __attribute__((debug_annotate_decl("decl-tag-3")))
+
+#define __typetag1 __attribute__((debug_annotate_type("type-tag-1")))
+#define __typetag2 __attribute__((debug_annotate_type("type-tag-2")))
+#define __typetag3 __attribute__((debug_annotate_type("type-tag-3")))
+
+/* Note the decl tags on these parameters will not be recorded... */
+
+extern int foo (int * __typetag1 x __decltag1,
+		char * __typetag3 c __decltag1 __decltag2);
+
+
+/* ... but here they will be.  */
+
+int bar (int * x __decltag1 __decltag3, char **buf __decltag2 __decltag3)
+{
+  return foo (x, buf[0]);
+}
+
+/* Verify that we get the expected DW_TAG_GNU_annotation DIEs for each tag.
+   Note: one more TAG in debug abbrev.  */
+/* { dg-final { scan-assembler-times " DW_TAG_GNU_annotation" 7 } } */
+/* { dg-final { scan-assembler-times " DW_AT_name: \"debug_annotate_decl\"" 4 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-1\"" 1 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-2\"" 1 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"decl-tag-3\"" 2 } } */
+/* { dg-final { scan-assembler-times " DW_AT_name: \"debug_annotate_type\"" 2 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-1\"" 1 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-2\"" 0 } } */
+/* { dg-final { scan-assembler-times " DW_AT_const_value: \"type-tag-3\"" 1 } } */